#include <vcl.h>
#include "Kalender.h"
#include <stdio.h>
#include "time.h"



//================================================================================
//
//================================================================================
__fastcall TKalender::TKalender(void)
{


};

//================================================================================
//
//================================================================================
__fastcall TKalender::~TKalender(void)
{


};

//===========================================================================
//
// return(-1); Ungueltige Kalenderwoche
//
//===========================================================================
int __fastcall TKalender::GetWeekOfYear(TDateTime dt)
{
int KW;
char weekOfYear[2];
time_t sin1970;
struct tm *ts;

KW=0;

sin1970 = time(NULL);
ts = localtime(&sin1970);

if(strftime(weekOfYear,3,"%W",ts)<0)
  {
  return(-1);
  }
  KW=atoi(weekOfYear)+1;


return(KW);
}

//===========================================================================
//
//===========================================================================
bool __fastcall TKalender::IsLeapYear(TDateTime dt)
{
unsigned short year,month,day;

dt.DecodeDate(&year,&month,&day);

// Die Regel lautet: Alles, was durch 4 teilbar ist, ist ein Schaltjahr.
// Es sei denn, das Jahr ist durch 100 teilbar, dann ist es keins.
// Aber wenn es durch 400 teilbar ist, ist es doch wieder eins.

if ((year % 400) == 0)    return(true);
else
if ((year % 100) == 0)    return(false);
else
if ((year % 4) == 0)      return(true);


return(false);
}

//===========================================================================
// return(-1); ungltiger Monat
//===========================================================================
short __fastcall TKalender::GetAnzahlTageImMonat(TDateTime dt)
{
unsigned short year,month,day;
//                     unglt,Jan,Feb,Mrz,Apr,Mai,Jun,Jul,Aug,Sep,Okt,Nov,Dez
int arrTageImMonat[13] = {  0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };


dt.DecodeDate(&year,&month,&day);

if(month == 2)
  {
  // Februar: Schaltjahr unterscheiden
  if (IsLeapYear(dt))    return 29;
  else                   return 28;
  }

if ((month >= 1) && (month <= 12))    return arrTageImMonat[month];
else
  {
  return(-1);
  }


}

//===========================================================================
// return(-1); ungltiger Monat
//===========================================================================
short __fastcall TKalender::GetAnzahlTageImJahr(TDateTime dt)
{
return (IsLeapYear(dt)) ? 366 : 365;
}

//===========================================================================
//
//===========================================================================
TDateTime __fastcall TKalender::GetOsterdatum(TDateTime dt)
{
unsigned short year,month,day;
UINT a,b,c;

dt.DecodeDate(&year,&month,&day);

a = year % 19;
b = year %  4;
c = year %  7;


// Berechnet fr ein beliebiges Jahr das Osterdatum.
// Quelle des Gauss - Algorithmus: Stefan Gerth,
// "Die Gau'sche Osterregel", Nrnberg, Februar 2003.
// http://krapfen.org/content/paper/Schule/Facharbeit/Berechnung_des_Osterfestes.pdf


int k = year / 100;
int q = k / 4;
int p = ((8 * k) + 13) / 25;
UINT Egz = (38 - (k - q) + p) % 30; // Die Jahrhundertepakte
UINT M = (53 - Egz) % 30;
UINT N = (4 + k - q) % 7;

UINT d = ((19 * a) + M) % 30;
UINT e = ((2 * b) + (4 * c) + (6 * d) + N) % 7;

// Ausrechnen des Ostertermins:
if((22 + d + e) <= 31)
  {
  day = 22 + d + e;
  month = 3;
  }
  else
  {
  day = d + e - 9;
  month = 4;

  // Zwei Ausnahmen bercksichtigen:
  if (day == 26)                                 day = 19;
  else
  if ((day == 25) && (d == 28) && (a > 10))      day = 18;
  }

  // Offsets fr andere Feiertage:

  // Schwerdonnerstag / Weiberfastnacht -52
  // Rosenmontag -48
  // Fastnachtsdienstag -47
  // Aschermittwoch -46
  // Grndonnerstag -3
  // Karfreitag -2
  // Ostersonntag 0
  // Ostermontag +1
  // Christi Himmelfahrt +39
  // Pfingstsonntag +49
  // Pfingstmontag +50
  // Fronleichnam +60

  // Mari Himmelfahrt ist stets am 15. August (Danke an Michael Plugge!)

return(TDateTime(year,month,day));
}



//===========================================================================
//
//===========================================================================
TDateTime __fastcall TKalender::GetViertenAdvent(TDateTime dt)
{
unsigned short year,month,day;

dt.DecodeDate(&year,&month,&day);

// Berechnet fr ein beliebiges Jahr das Datum des 4. Advents-Sonntags.
// Der 4. Adventssonntag ist stets der Sonntag vor dem 1. Weihnachtsfeiertag,
// mu also stets in der Periode [18. - 24.12.] liegen:

month = 12; // Das steht jedes Jahr fest :-)

short nWoTag = dt.DayOfWeek()-1;

day = 24 - nWoTag;

// Offsets: Der Bu- und Bettag liegt stets 32 Tage vor dem  4. Advent

return(TDateTime(year,month,day));
}

